; ----------------------------------------------------------------------------
; -       TITULO  : Ejemplo de juego ahorcado W-MASM                         -
; -----                                                                  -----
; -       AUTOR   : Alfonso Vctor Caballero Hurtado                         -
; -----                                                                  -----
; -       VERSION : 1.0                                                      -
; -----                                                                  -----
; -      (c) 2010. Abre los Ojos al Ensamblador                              -
; ----------------------------------------------------------------------------

.386

.MODEL      flat, stdcall
OPTION      casemap:none

INCLUDE     windows.inc      ; Inclumos definiciones de estructuras y constantes
INCLUDE     user32.inc       ; Inclumos los prototipos de uso ms habitual
INCLUDE     kernel32.inc     ; Inclumos los prototipos de uso ms habitual
INCLUDE     gdi32.inc        ; Inclumos los prototipos de uso ms habitual
INCLUDELIB  user32.lib       ; Importamos las bibliotecas para que el enlazador pueda trabajar
INCLUDELIB  kernel32.lib     ; Importamos las bibliotecas para que el enlazador pueda trabajar
INCLUDELIB  gdi32.lib        ; Importamos las bibliotecas para que el enlazador pueda trabajar

cdXPos         EQU  28  
cdYPos         EQU  100 
cdXSize        EQU  310 
cdYSize        EQU  200 
cdColFondo     EQU  COLOR_BTNFACE + 1
cdMAIN_ICON    EQU  100    
cdWINDOW_ICON  EQU  100    
cdVIcono       EQU  IDI_APPLICATION 
cdVCursor      EQU  IDC_ARROW  
cdWords        EQU  15         
cdVBarTipo     EQU  NULL       
cdVBtnTipo     EQU  WS_VISIBLE+WS_DLGFRAME+WS_SYSMENU  
cdFXPos1       EQU  50
cdFYPos1       EQU  70
cdFXPos2       EQU  50
cdFYPos2       EQU  30
cdFSize        EQU  20          ; Tamao del texto

WinMain           PROTO :DWORD,:DWORD,:DWORD,:DWORD
MakeFont          proto :DWORD, :DWORD
ActualizaIntentos proto
Inicializa        proto :dword
chkLetrasUsadas   proto
chkLetra          proto
setWord           proto
setMsgTexto       proto
Random            proto  

.DATA
  szStatic      db    'STATIC', 0
  MsgCabecera   db    'Hangman. 100% MASM code',0
  NombreClase   db    'EXP01',0
  msgCabecera   db    'Information', 0
  msgSuccess    db    'You win. Play again?', 0
  msgLoose      db    'You loose. Play again?', 0
  MsgError      db    'Initial load failed.',0
  msgIntentos   db    'You have 0 attempts yet', 0
  msgAutor      db    '(c) Abre los Ojos al Ensamblador', 13, 10
                db    'http://www.abreojosensamblador.net', 0
  vsGuion       db    '_ '
  MsgTexto2     db    26 dup (' '),0
  msgUsedKeys   db    'Used keys: '
  vsmLetras     db    17 dup (0)               ; Matriz que recoge las letras pulsadas
  ;seed          dd    2037280626
  
  szCourierNew  DB    "Courier New",0
  szVerdana     DB    "Verdana",0
  Palabras      DB    "HELLO",     0, "FANTASTIC", 0, "ENCOURAGE", 0
                DB    "RECTANGLE", 0, "SMALL",     0, "SQUALL",    0
                DB    "PAUNCH",    0, "FLAUNT",    0, "ESCAPE",    0
                DB    "AWARE",     0, "GALORE",    0, "SPREAD",    0
                DB    "STRAIGHT",  0, "FRIGHT",    0, "ACUSE",     0
  cdLonMatriz   equ   $-Palabras

.DATA?
  wMsg          MSG <>
  ps            PAINTSTRUCT <>
  wc            WNDCLASSEX  <>
  CommandLine   DD    ?
  vbContLetras  db    ?                          ; Contador de letras pulsadas
  vbAciertos    db    ?                          ; Contador de letras acertadas
  vbLetra       db    ?                          ; Letra pulsada
  vpPalabra     dd    ?                          ; Puntero a la palabra a buscar
  vbQueda       db    ?                          ; Intentos que quedan
  hdc           dd    ?
  hGuessNFont   dd    ?
  hGuessOFont   dd    ?
  hAttemNFont   dd    ?
  hAttemOFont   dd    ?
  vdLong        dd    ?
  vwdIntentos   dd    ?
  vwdAutor      dd    ?
  wHMain        dd    ?
  seed          dd    ?

.CODE
  start:
    INVOKE    GetModuleHandle, NULL
    MOV       wc.hInstance, EAX
    INVOKE    GetCommandLine
    MOV       CommandLine, EAX
    INVOKE    WinMain, wc.hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    INVOKE    ExitProcess, EAX

  WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
    ;  Propsito: Inicializamos la ventana principal de la aplicacin y captura errores, si los hubiere
    ;  Entrada  : hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    LOCAL     msg:MSG
    LOCAL     hwnd:HWND
    ; Si inicializamos wc con sus valores corremos el riesgo de hacerlo desordenadamente en caso
    ; de que se cambie la definicin de la estructura WNDCLASSEX
    MOV       wc.cbSize, SIZEOF WNDCLASSEX
    MOV       wc.style, CS_HREDRAW OR CS_VREDRAW
    MOV       wc.lpfnWndProc, OFFSET WndProc
    MOV       wc.cbClsExtra, NULL
    MOV       wc.cbWndExtra, NULL
    ; hInstance ya est valorado arriba
    MOV       wc.hbrBackground, cdColFondo  ; Color de fondo de la ventana
    MOV       wc.lpszMenuName, NULL
    MOV       wc.lpszClassName, OFFSET NombreClase
    INVOKE    LoadIcon, hInst,cdMAIN_ICON
    MOV       wc.hIcon, EAX
    INVOKE    LoadIcon, hInst,cdWINDOW_ICON
    MOV       wc.hIconSm, EAX
    INVOKE    LoadCursor, NULL, cdVCursor
    MOV       wc.hCursor, EAX
    INVOKE    RegisterClassEx, ADDR wc
    TEST      EAX, EAX
    JZ        L_Error
    INVOKE    CreateWindowEx,cdVBarTipo,ADDR NombreClase,ADDR MsgCabecera,\
              cdVBtnTipo,cdXPos, cdYPos, cdXSize, cdYSize,\
              NULL,NULL,hInst,NULL
    TEST      EAX, EAX
    JZ        L_Error
    MOV       hwnd, EAX
    INVOKE    ShowWindow, hwnd, SW_SHOWNORMAL
    INVOKE    UpdateWindow, hwnd

    .WHILE    TRUE
        INVOKE    GetMessage, ADDR msg, NULL, 0, 0
        .BREAK    .IF (!EAX)
        INVOKE    TranslateMessage, ADDR msg
        INVOKE    DispatchMessage, ADDR msg
    .ENDW
    JMP       L_Fin

    L_Error:
      INVOKE    MessageBox, NULL,ADDR MsgError, NULL, MB_ICONERROR+MB_OK

    L_Fin:
    MOV       EAX, msg.wParam
    RET
  WinMain ENDP
  
  WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    ;  Propsito: Procesa los mensajes provenientes de las ventanas
    ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    MOV       EAX, uMsg
    .IF       uMsg == WM_DESTROY
      @wmdestroy:
      invoke    DeleteObject, [hGuessNFont]
      invoke    DeleteObject, [hGuessOFont]
      invoke    DeleteObject, [hAttemNFont]
      invoke    DeleteObject, [hAttemOFont]
      invoke    PostQuitMessage, NULL
    .ELSEIF   uMsg == WM_PAINT
      INVOKE    BeginPaint,[hWnd], ADDR ps
      mov       [hdc], eax
      ; Aqu dibujamos la palabra a descubrir
      invoke    SetBkColor,[ps.hdc],NULL        ; Color de fondo
      invoke    SetTextColor,[ps.hdc],0FFFFFFh  ; Color del texto
      invoke    SelectObject, [hdc], [hGuessNFont]
      mov       [hGuessOFont], eax
      invoke    lstrlen, ADDR MsgTexto2
      invoke    TextOut, [hdc], cdFXPos2,cdFYPos2, ADDR MsgTexto2, eax
      ; Aqu ponemos lo que nos queda
      invoke    SetBkColor,[ps.hdc],011A3FBh     ; Color de fondo
      invoke    SetTextColor,[ps.hdc],0ffh       ; Color del texto
      invoke    SelectObject, [hdc], [hAttemNFont]
      mov       [hAttemOFont], eax
      invoke    lstrlen, ADDR msgIntentos
      invoke    TextOut, [hdc], cdFXPos1,cdFYPos1, ADDR msgIntentos, eax
      invoke    EndPaint,[hWnd], ADDR ps
      ; Aqu comprobamos qu tal ha ido la cosa
      or        [vbQueda], 0              ; Quedan intentos?
      jnz       @Aciertos
        invoke    MessageBox, [hWnd], ADDR msgLoose, ADDR msgCabecera, MB_YESNO+MB_ICONERROR
        .IF      EAX != IDNO
          invoke    Inicializa, [hWnd]
        .ELSE
          jmp      @wmdestroy
        .ENDIF
      @Aciertos:
      mov       al, [vbAciertos]         ; Hemos acertado todas las letras?
      cmp       byte ptr [vdLong], al
      jnz       Sgte01
        invoke    MessageBox,[hWnd],ADDR msgSuccess,ADDR msgCabecera,MB_YESNO+MB_ICONEXCLAMATION
        .IF      EAX != IDNO
          invoke    Inicializa, [hWnd]
        .ELSE
          jmp      @wmdestroy
        .ENDIF
      Sgte01:
    .ELSEIF   uMsg == WM_CHAR
      push      [wParam]
      pop       eax
      and       al, 1011111b     ; Lo convertimos a maysculas
      mov       byte ptr [vbLetra], al
      invoke    chkLetrasUsadas  ; Comprobamos que no la hayamos usado ya
      JZ        @YaUsada
        invoke    chkLetra
      @YaUsada:
      invoke    SetWindowText,[vwdIntentos], ADDR msgUsedKeys  ; Con esto cambiamos el texto
      invoke    InvalidateRect, [hWnd], NULL, TRUE
    .ELSEIF   uMsg == WM_CREATE
      invoke    GetTickCount
      mov       [seed], eax
      invoke    MakeFont,cdFSize,ADDR szCourierNew
      mov       [hGuessNFont], eax
      invoke    MakeFont,14,ADDR szVerdana
      mov       [hAttemNFont], eax
      ; Creamos el label de los intentos que quedan
      invoke   CreateWindowEx,NULL,ADDR szStatic,ADDR msgUsedKeys,\
               WS_CHILD + WS_VISIBLE + SS_CENTER,35, 90, 190, 30,\
               [hWnd],500,[wc.hInstance],NULL
      mov      [vwdIntentos], eax
      invoke   SendMessage,eax,WM_SETFONT,NULL,0
      ; Creamos el label del autor
      invoke   CreateWindowEx,NULL,ADDR szStatic,ADDR msgAutor,\
               WS_CHILD + WS_VISIBLE + SS_CENTER,15,120, 270, 70,\
               [hWnd],500,[wc.hInstance],NULL
      mov      [vwdAutor], eax
      invoke   SendMessage,eax,WM_SETFONT,NULL,0
      invoke    Inicializa, [hWnd]
    .ELSE
        INVOKE    DefWindowProc, hWnd, uMsg, wParam, lParam
        RET
    .ENDIF
    XOR       EAX, EAX
    RET
  WndProc ENDP

  MakeFont proc pSize:DWORD, pFontName:DWORD
    invoke    CreateFont, [pSize],0,0,0, FW_BOLD, FALSE,FALSE,FALSE, \
              ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
              DEFAULT_QUALITY, 18, [pFontName]
    ret
  MakeFont endp

  ActualizaIntentos proc
    ; Propsito: Actualizamos los intentos en msgIntentos
    ; Entrada  : vbQueda
    ; Salida   : Ninguna
    mov       al, [vbQueda]
    or        al, 30h
    mov       byte ptr [msgIntentos+9], al
  ret
  ActualizaIntentos endp

  Inicializa proc pWnd:dword
    ; Propsito: Inicializa el juego
    ; Entrada  : Ninguna
    ; Salida   : Ninguna
    mov       [vbContLetras], 0
    mov       [vbAciertos], 0
    mov       edi, offset vsmLetras       ; Inicializa matriz de teclas usadas
    mov       eax, 20202020h
    mov       ecx, 4
    rep       stosd
    invoke    setWord
    invoke    setMsgTexto
    mov       eax, [vdLong]
    shr       eax, 1
    mov       [vbQueda], al
    invoke    ActualizaIntentos
    invoke    SetWindowText,[vwdIntentos], addr msgUsedKeys  ; Con esto cambiamos el texto
    invoke    InvalidateRect, [pWnd], NULL, TRUE
    ret
  Inicializa endp

  chkLetrasUsadas proc
    ; Propsito: Comprobamos si ya se ha usado una letra, se guarda en matriz de usadas
    ; Entrada  : vbLetra
    ; Salida   : ZF:1 -> ya fue usada, ZF:0 -> no fue usada
    mov      al, [vbLetra]
    cmp      [vbContLetras], 0
    jnz      @Siguiente
      ; Si an no hemos pulsado una tecla, es que no la hemos usado
      mov      [vsmLetras], al      ; Lo guardamos en la matriz de las letras
      inc      [vbContLetras]
      ; Devolvemos ZF=0
      jmp      @Exit
    @Siguiente:
      ; Si ya hemos usado algunas letras, vamos a ver si son de las ya usadas
      xor       ecx, ecx
      mov       cl, [vbContLetras]
      mov       ebx, ecx
      mov       edi, offset vsmLetras
      repne     scasb
      jz        @Exit                     ; Si lo hubiramos encontrado, saltaramos
        ; Si estamos aqu es porque no lo hemos encontrado, lo incorporamos
        mov       [vsmLetras+ebx], al     ; Lo guardamos en la matriz de las letras
        inc       [vbContLetras]
        ; Devolvemos ZF=0
    @Exit:
    ret
  chkLetrasUsadas endp 

  chkLetra proc
    ; Propsito: Busca la letra pulsada en toda la palabra
    ; Entrada  : vbLetra, vpPalabra: puntero a la palabra, vdLong: longitud palabra
    ; Salida   : Ninguna
    mov       ecx, [vdLong]
    mov       edi, [vpPalabra]
    mov       al, [vbLetra]
    mov       ah, 0              ; Suponemos que no hemos encontrado ninguna ocurrencia
    @RepetirBusqueda:
      repne     scasb
      jne       @NoEncontrado
        ; Si estamos aqu es porque hemos encontrado la letra en la palabra
        mov       ebx, [vdLong]
        sub       ebx, ecx
        dec       ebx
        shl       ebx, 1
        mov       [MsgTexto2+ebx], al
        inc       [vbAciertos]
        mov       ah, 1          ; Hemos encontrado al menos una ocurrencia
        jnz       @RepetirBusqueda
    @NoEncontrado:
      cmp       ah, 1
      jz        @fin
        dec       [vbQueda]
        invoke    ActualizaIntentos
    @fin:
    ret
  chkLetra endp

  setWord proc
    ; Propsito: Escoge una palabra de la lista que deberemos adivinar
    ; Entrada  : Ninguna
    ; Salida   : esi -> apunta a la palabra a adivinar
    mov       eax, cdWords
    invoke    Random             ; eax
    inc       eax
    mov       edx, eax
    mov       ecx, cdLonMatriz
    mov       edi, offset Palabras
    mov       al, 0
    @Bucle:
      mov       esi, edi
      dec       edx
      jz        @FinBucle
      repne     scasb
    jmp       @Bucle
    @FinBucle:
    mov       [vpPalabra], esi
    invoke    lstrlen, esi
    mov       [vdLong], eax
    @Fin:
    ret
  setWord endp

  setMsgTexto proc
    ; Propsito: Establecemos MsgTexto
    ; Entrada  : vdLong -> longitud de la palabra a adivinar
    ; Salida   : ninguna
    push       ecx
    push       esi
    push       edi
    mov        esi, offset vsGuion
    mov        ecx, [vdLong]
    mov        edi, offset MsgTexto2
    rep        movsw
    dec        edi
    mov        al, 0
    stosb
    pop        edi
    pop        esi
    pop        ecx
    ret
  setMsgTexto endp

  Random proc  
    ;  Propsito: Calculamos un nmero aleatorio en [0..eax-1] by Park Miller
    ;  Entrada  : eax
    ;  Salida   : eax
    ;  Destruye : Ninguna
    mov        ebx, eax
    mov        eax, [seed]   ; from M32lib/nrand.asm
    xor        edx, edx
    mov        ecx, 127773
    div        ecx 
    mov        ecx, eax
    mov        eax, 16807
    mul        edx 
    mov        edx, ecx
    mov        ecx, eax
    mov        eax, 2836
    mul        edx 
    sub        ecx, eax
    xor        edx, edx
    mov        eax, ecx
    mov        [seed], ecx 
    div        ebx;[base]
    mov        eax, edx
    ret
  Random endp
END start
